"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.toBase64 = exports.toValAddress = exports.toAccAddress = exports.fromBase64 = exports.fromValAddress = exports.fromAccAddress = void 0;
const bech32_1 = require("bech32");
const consts_1 = require("./consts");
function fromAccAddress(address) {
    return { bytes: Buffer.from(bech32_1.bech32.fromWords(bech32_1.bech32.decode(address).words)) };
}
exports.fromAccAddress = fromAccAddress;
function fromValAddress(valAddress) {
    return {
        bytes: Buffer.from(bech32_1.bech32.fromWords(bech32_1.bech32.decode(valAddress).words)),
    };
}
exports.fromValAddress = fromValAddress;
function fromBase64(address) {
    return { bytes: Buffer.from(address, "base64") };
}
exports.fromBase64 = fromBase64;
function toAccAddress(address) {
    return bech32_1.bech32.encode(consts_1.ADDRESS_PREFIX, bech32_1.bech32.toWords(address.bytes));
}
exports.toAccAddress = toAccAddress;
function toValAddress(address) {
    return bech32_1.bech32.encode(consts_1.OPERATOR_PREFIX, bech32_1.bech32.toWords(address.bytes));
}
exports.toValAddress = toValAddress;
function toBase64(address) {
    return Buffer.from(address.bytes).toString("base64");
}
exports.toBase64 = toBase64;
