import { DirectSecp256k1HdWallet } from "@cosmjs/proto-signing";
import { QueryClient, StargateClient, StdFee } from "@cosmjs/stargate";
import { RpcStatus, HttpResponse } from "../modules/wormhole_foundation.wormchain.wormhole/rest";
export declare const TENDERMINT_URL = "http://localhost:26658";
export declare const WORM_DENOM = "uworm";
export declare const LCD_URL = "http://localhost:1318";
export declare function getStargateQueryClient(): Promise<QueryClient & import("@cosmjs/stargate").TxExtension & import("@cosmjs/stargate").GovExtension & import("@cosmjs/stargate").IbcExtension & import("@cosmjs/stargate").AuthExtension & import("@cosmjs/stargate").BankExtension & import("@cosmjs/stargate").MintExtension & import("@cosmjs/stargate").StakingExtension>;
export declare function getStargateClient(): Promise<StargateClient>;
export declare function getZeroFee(): StdFee;
export declare function getWallet(mnemonic: string): Promise<DirectSecp256k1HdWallet>;
export declare function getAddress(wallet: DirectSecp256k1HdWallet): Promise<string>;
export declare function executeGovernanceVAA(wallet: DirectSecp256k1HdWallet, hexVaa: string): Promise<import("@cosmjs/stargate").DeliverTxResponse>;
export declare function getGuardianSets(): Promise<import("../modules/wormhole_foundation.wormchain.wormhole/rest").WormholeQueryAllGuardianSetResponse>;
export declare function getConsensusGuardianSet(): Promise<import("../modules/wormhole_foundation.wormchain.wormhole/rest").WormholeQueryGetConsensusGuardianSetIndexResponse>;
export declare function getValidators(): Promise<import("cosmjs-types/cosmos/staking/v1beta1/query").QueryValidatorsResponse>;
export declare function getGuardianValidatorRegistrations(): Promise<import("../modules/wormhole_foundation.wormchain.wormhole/rest").WormholeQueryAllGuardianValidatorResponse>;
export declare function unpackHttpReponse<T>(response: Promise<HttpResponse<T, RpcStatus>>): Promise<T>;
export declare function registerGuardianValidator(wallet: DirectSecp256k1HdWallet, guardianPubkeyBase64: string, guardianPrivkeyHex: string, valAddress: string): Promise<any>;
export declare function fromAccAddress(address: string): BinaryAddress;
export declare function fromValAddress(valAddress: string): BinaryAddress;
export declare function fromBase64(address: string): BinaryAddress;
export declare function toAccAddress(address: BinaryAddress): string;
export declare function toValAddress(address: BinaryAddress): string;
export declare function toBase64(address: BinaryAddress): string;
declare type BinaryAddress = {
    bytes: Uint8Array;
};
export {};
