import { OfflineSigner } from "@cosmjs/proto-signing";
import { SigningStargateClient, SigningStargateClientOptions } from "@cosmjs/stargate";
export declare const MissingWalletError: Error;
export declare const getWormchainSigningClient: (tendermintAddress: string, wallet: OfflineSigner, options?: SigningStargateClientOptions | undefined) => Promise<SigningStargateClient & {
    core: Omit<{
        signAndBroadcast: undefined;
        msgExecuteGatewayGovernanceVaa: (data: import("../modules/wormhole_foundation.wormchain.wormhole/types/wormhole/tx").MsgExecuteGatewayGovernanceVaa) => import("@cosmjs/proto-signing").EncodeObject;
        msgRegisterAccountAsGuardian: (data: import("../modules/wormhole_foundation.wormchain.wormhole/types/wormhole/tx").MsgRegisterAccountAsGuardian) => import("@cosmjs/proto-signing").EncodeObject;
        msgInstantiateContract: (data: import("../modules/wormhole_foundation.wormchain.wormhole/types/wormhole/tx").MsgInstantiateContract) => import("@cosmjs/proto-signing").EncodeObject;
        msgExecuteGovernanceVAA: (data: import("../modules/wormhole_foundation.wormchain.wormhole/types/wormhole/tx").MsgExecuteGovernanceVAA) => import("@cosmjs/proto-signing").EncodeObject;
        msgStoreCode: (data: import("../modules/wormhole_foundation.wormchain.wormhole/types/wormhole/tx").MsgStoreCode) => import("@cosmjs/proto-signing").EncodeObject;
        msgAddWasmInstantiateAllowlist: (data: import("../modules/wormhole_foundation.wormchain.wormhole/types/wormhole/tx").MsgAddWasmInstantiateAllowlist) => import("@cosmjs/proto-signing").EncodeObject;
        msgDeleteWasmInstantiateAllowlist: (data: import("../modules/wormhole_foundation.wormchain.wormhole/types/wormhole/tx").MsgDeleteWasmInstantiateAllowlist) => import("@cosmjs/proto-signing").EncodeObject;
        msgMigrateContract: (data: import("../modules/wormhole_foundation.wormchain.wormhole/types/wormhole/tx").MsgMigrateContract) => import("@cosmjs/proto-signing").EncodeObject;
        msgDeleteAllowlistEntryRequest: (data: import("../modules/wormhole_foundation.wormchain.wormhole/types/wormhole/tx").MsgDeleteAllowlistEntryRequest) => import("@cosmjs/proto-signing").EncodeObject;
        msgCreateAllowlistEntryRequest: (data: import("../modules/wormhole_foundation.wormchain.wormhole/types/wormhole/tx").MsgCreateAllowlistEntryRequest) => import("@cosmjs/proto-signing").EncodeObject;
    }, "signAndBroadcast">;
    auth: Omit<{
        signAndBroadcast: undefined;
    }, "signAndBroadcast">;
    bank: Omit<{
        signAndBroadcast: undefined;
        msgMultiSend: (data: import("../modules/cosmos.bank.v1beta1/types/cosmos/bank/v1beta1/tx").MsgMultiSend) => import("@cosmjs/proto-signing").EncodeObject;
        msgSend: (data: import("../modules/cosmos.bank.v1beta1/types/cosmos/bank/v1beta1/tx").MsgSend) => import("@cosmjs/proto-signing").EncodeObject;
    }, "signAndBroadcast">;
    base: Omit<{
        signAndBroadcast: undefined;
    }, "signAndBroadcast">;
    crisis: Omit<{
        signAndBroadcast: undefined;
        msgVerifyInvariant: (data: import("../modules/cosmos.crisis.v1beta1/types/cosmos/crisis/v1beta1/tx").MsgVerifyInvariant) => import("@cosmjs/proto-signing").EncodeObject;
    }, "signAndBroadcast">;
    distribution: Omit<{
        signAndBroadcast: undefined;
        msgWithdrawValidatorCommission: (data: import("../modules/cosmos.distribution.v1beta1/types/cosmos/distribution/v1beta1/tx").MsgWithdrawValidatorCommission) => import("@cosmjs/proto-signing").EncodeObject;
        msgSetWithdrawAddress: (data: import("../modules/cosmos.distribution.v1beta1/types/cosmos/distribution/v1beta1/tx").MsgSetWithdrawAddress) => import("@cosmjs/proto-signing").EncodeObject;
        msgWithdrawDelegatorReward: (data: import("../modules/cosmos.distribution.v1beta1/types/cosmos/distribution/v1beta1/tx").MsgWithdrawDelegatorReward) => import("@cosmjs/proto-signing").EncodeObject;
        msgFundCommunityPool: (data: import("../modules/cosmos.distribution.v1beta1/types/cosmos/distribution/v1beta1/tx").MsgFundCommunityPool) => import("@cosmjs/proto-signing").EncodeObject;
    }, "signAndBroadcast">;
    evidence: Omit<{
        signAndBroadcast: undefined;
        msgSubmitEvidence: (data: import("../modules/cosmos.evidence.v1beta1/types/cosmos/evidence/v1beta1/tx").MsgSubmitEvidence) => import("@cosmjs/proto-signing").EncodeObject;
    }, "signAndBroadcast">;
    feegrant: Omit<{
        signAndBroadcast: undefined;
        msgGrantAllowance: (data: import("../modules/cosmos.feegrant.v1beta1/types/cosmos/feegrant/v1beta1/tx").MsgGrantAllowance) => import("@cosmjs/proto-signing").EncodeObject;
        msgRevokeAllowance: (data: import("../modules/cosmos.feegrant.v1beta1/types/cosmos/feegrant/v1beta1/tx").MsgRevokeAllowance) => import("@cosmjs/proto-signing").EncodeObject;
    }, "signAndBroadcast">;
    gov: Omit<{
        signAndBroadcast: undefined;
        msgDeposit: (data: import("../modules/cosmos.gov.v1beta1/types/cosmos/gov/v1beta1/tx").MsgDeposit) => import("@cosmjs/proto-signing").EncodeObject;
        msgVote: (data: import("../modules/cosmos.gov.v1beta1/types/cosmos/gov/v1beta1/tx").MsgVote) => import("@cosmjs/proto-signing").EncodeObject;
        msgVoteWeighted: (data: import("../modules/cosmos.gov.v1beta1/types/cosmos/gov/v1beta1/tx").MsgVoteWeighted) => import("@cosmjs/proto-signing").EncodeObject;
        msgSubmitProposal: (data: import("../modules/cosmos.gov.v1beta1/types/cosmos/gov/v1beta1/tx").MsgSubmitProposal) => import("@cosmjs/proto-signing").EncodeObject;
    }, "signAndBroadcast">;
    mint: Omit<{
        signAndBroadcast: undefined;
    }, "signAndBroadcast">;
    params: Omit<{
        signAndBroadcast: undefined;
    }, "signAndBroadcast">;
    slashing: Omit<{
        signAndBroadcast: undefined;
        msgUnjail: (data: import("../modules/cosmos.slashing.v1beta1/types/cosmos/slashing/v1beta1/tx").MsgUnjail) => import("@cosmjs/proto-signing").EncodeObject;
    }, "signAndBroadcast">;
    staking: Omit<{
        signAndBroadcast: undefined;
        msgCreateValidator: (data: import("../modules/cosmos.staking.v1beta1/types/cosmos/staking/v1beta1/tx").MsgCreateValidator) => import("@cosmjs/proto-signing").EncodeObject;
        msgDelegate: (data: import("../modules/cosmos.staking.v1beta1/types/cosmos/staking/v1beta1/tx").MsgDelegate) => import("@cosmjs/proto-signing").EncodeObject;
        msgEditValidator: (data: import("../modules/cosmos.staking.v1beta1/types/cosmos/staking/v1beta1/tx").MsgEditValidator) => import("@cosmjs/proto-signing").EncodeObject;
        msgUndelegate: (data: import("../modules/cosmos.staking.v1beta1/types/cosmos/staking/v1beta1/tx").MsgUndelegate) => import("@cosmjs/proto-signing").EncodeObject;
        msgBeginRedelegate: (data: import("../modules/cosmos.staking.v1beta1/types/cosmos/staking/v1beta1/tx").MsgBeginRedelegate) => import("@cosmjs/proto-signing").EncodeObject;
    }, "signAndBroadcast">;
    tx: Omit<{
        signAndBroadcast: undefined;
    }, "signAndBroadcast">;
    upgrade: Omit<{
        signAndBroadcast: undefined;
    }, "signAndBroadcast">;
    vesting: Omit<{
        signAndBroadcast: undefined;
        msgCreateVestingAccount: (data: import("../modules/cosmos.vesting.v1beta1/types/cosmos/vesting/v1beta1/tx").MsgCreateVestingAccount) => import("@cosmjs/proto-signing").EncodeObject;
    }, "signAndBroadcast">;
    wasm: Omit<{
        signAndBroadcast: undefined;
        msgInstantiateContract: (data: import("../modules/cosmwasm.wasm.v1/types/cosmwasm/wasm/v1/tx").MsgInstantiateContract) => import("@cosmjs/proto-signing").EncodeObject;
        msgUpdateAdmin: (data: import("../modules/cosmwasm.wasm.v1/types/cosmwasm/wasm/v1/tx").MsgUpdateAdmin) => import("@cosmjs/proto-signing").EncodeObject;
        msgInstantiateContract2: (data: import("../modules/cosmwasm.wasm.v1/types/cosmwasm/wasm/v1/tx").MsgInstantiateContract2) => import("@cosmjs/proto-signing").EncodeObject;
        msgIBCCloseChannel: (data: import("../modules/cosmwasm.wasm.v1/types/cosmwasm/wasm/v1/ibc").MsgIBCCloseChannel) => import("@cosmjs/proto-signing").EncodeObject;
        msgMigrateContract: (data: import("../modules/cosmwasm.wasm.v1/types/cosmwasm/wasm/v1/tx").MsgMigrateContract) => import("@cosmjs/proto-signing").EncodeObject;
        msgStoreCode: (data: import("../modules/cosmwasm.wasm.v1/types/cosmwasm/wasm/v1/tx").MsgStoreCode) => import("@cosmjs/proto-signing").EncodeObject;
        msgExecuteContract: (data: import("../modules/cosmwasm.wasm.v1/types/cosmwasm/wasm/v1/tx").MsgExecuteContract) => import("@cosmjs/proto-signing").EncodeObject;
        msgClearAdmin: (data: import("../modules/cosmwasm.wasm.v1/types/cosmwasm/wasm/v1/tx").MsgClearAdmin) => import("@cosmjs/proto-signing").EncodeObject;
        msgIBCSend: (data: import("../modules/cosmwasm.wasm.v1/types/cosmwasm/wasm/v1/ibc").MsgIBCSend) => import("@cosmjs/proto-signing").EncodeObject;
    }, "signAndBroadcast">;
}>;
