"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getWormchainSigningClient = exports.MissingWalletError = void 0;
const proto_signing_1 = require("@cosmjs/proto-signing");
const stargate_1 = require("@cosmjs/stargate");
const authModule = __importStar(require("../modules/cosmos.auth.v1beta1"));
const bankModule = __importStar(require("../modules/cosmos.bank.v1beta1"));
const baseModule = __importStar(require("../modules/cosmos.base.tendermint.v1beta1"));
const crisisModule = __importStar(require("../modules/cosmos.crisis.v1beta1"));
const distributionModule = __importStar(require("../modules/cosmos.distribution.v1beta1"));
const evidenceModule = __importStar(require("../modules/cosmos.evidence.v1beta1"));
const feegrantModule = __importStar(require("../modules/cosmos.feegrant.v1beta1"));
const govModule = __importStar(require("../modules/cosmos.gov.v1beta1"));
const mintModule = __importStar(require("../modules/cosmos.mint.v1beta1"));
const paramsModule = __importStar(require("../modules/cosmos.params.v1beta1"));
const slashingModule = __importStar(require("../modules/cosmos.slashing.v1beta1"));
const stakingModule = __importStar(require("../modules/cosmos.staking.v1beta1"));
const txModule = __importStar(require("../modules/cosmos.tx.v1beta1"));
const upgradeModule = __importStar(require("../modules/cosmos.upgrade.v1beta1"));
const vestingModule = __importStar(require("../modules/cosmos.vesting.v1beta1"));
const wasmModule = __importStar(require("../modules/cosmwasm.wasm.v1"));
const coreModule = __importStar(require("../modules/wormhole_foundation.wormchain.wormhole"));
//protobuf isn't guaranteed to have long support, which is used by the stargate signing client,
//so we're going to use an independent long module and shove it into the globals of protobuf
var Long = require("long");
var protobuf = require("protobufjs");
protobuf.util.Long = Long;
protobuf.configure();
//Rip the types out of their modules. These are private fields on the module.
//@ts-ignore
const coreTypes = coreModule.registry.types;
//@ts-ignore
const authTypes = authModule.registry.types;
//@ts-ignore
const bankTypes = bankModule.registry.types;
//@ts-ignore
const baseTypes = baseModule.registry.types;
//@ts-ignore
const crisisTypes = crisisModule.registry.types;
//@ts-ignore
const distributionTypes = distributionModule.registry.types;
//@ts-ignore
const evidenceTypes = evidenceModule.registry.types;
//@ts-ignore
const feegrantTypes = feegrantModule.registry.types;
//@ts-ignore
const govTypes = govModule.registry.types;
//@ts-ignore
const mintTypes = mintModule.registry.types;
//@ts-ignore
const paramsTypes = paramsModule.registry.types;
//@ts-ignore
const slashingTypes = slashingModule.registry.types;
//@ts-ignore
const stakingTypes = stakingModule.registry.types;
//@ts-ignore
const txTypes = txModule.registry.types;
//@ts-ignore
const upgradeTypes = upgradeModule.registry.types;
//@ts-ignore
const vestingTypes = vestingModule.registry.types;
//@ts-ignore
const wasmTypes = wasmModule.registry.types;
const aggregateTypes = [
    ...coreTypes,
    ...authTypes,
    ...bankTypes,
    ...baseTypes,
    ...crisisTypes,
    ...distributionTypes,
    ...evidenceTypes,
    ...feegrantTypes,
    ...govTypes,
    ...mintTypes,
    ...paramsTypes,
    ...slashingTypes,
    ...stakingTypes,
    ...txTypes,
    ...upgradeTypes,
    ...vestingTypes,
    ...wasmTypes,
];
exports.MissingWalletError = new Error("wallet is required");
const registry = new proto_signing_1.Registry(aggregateTypes);
const getWormchainSigningClient = async (tendermintAddress, wallet, options) => {
    if (!wallet)
        throw exports.MissingWalletError;
    const coreClient = await coreModule.txClient(wallet, {
        addr: tendermintAddress,
    });
    const authClient = await authModule.txClient(wallet, {
        addr: tendermintAddress,
    });
    const bankClient = await bankModule.txClient(wallet, {
        addr: tendermintAddress,
    });
    const baseClient = await baseModule.txClient(wallet, {
        addr: tendermintAddress,
    });
    const crisisClient = await crisisModule.txClient(wallet, {
        addr: tendermintAddress,
    });
    const distributionClient = await distributionModule.txClient(wallet, {
        addr: tendermintAddress,
    });
    const evidenceClient = await evidenceModule.txClient(wallet, {
        addr: tendermintAddress,
    });
    const feegrantClient = await feegrantModule.txClient(wallet, {
        addr: tendermintAddress,
    });
    const govClient = await govModule.txClient(wallet, {
        addr: tendermintAddress,
    });
    const mintClient = await mintModule.txClient(wallet, {
        addr: tendermintAddress,
    });
    const paramsClient = await paramsModule.txClient(wallet, {
        addr: tendermintAddress,
    });
    const slashingClient = await slashingModule.txClient(wallet, {
        addr: tendermintAddress,
    });
    const stakingClient = await stakingModule.txClient(wallet, {
        addr: tendermintAddress,
    });
    const txClient = await txModule.txClient(wallet, {
        addr: tendermintAddress,
    });
    const upgradeClient = await upgradeModule.txClient(wallet, {
        addr: tendermintAddress,
    });
    const vestingClient = await vestingModule.txClient(wallet, {
        addr: tendermintAddress,
    });
    const wasmClient = await wasmModule.txClient(wallet, {
        addr: tendermintAddress,
    });
    const client = await stargate_1.SigningStargateClient.connectWithSigner(tendermintAddress, wallet, {
        ...options,
        registry,
    });
    //This has some relevant info, but doesn't get us all the way there
    //https://github.com/cosmos/cosmjs/pull/712/files
    //The signAndBroadcast function needs to be undefined here because it uses and interface which can't be
    //resolved by typescript.
    const coreShell = {
        ...coreClient,
        signAndBroadcast: undefined,
    };
    delete coreShell.signAndBroadcast;
    const authShell = {
        ...authClient,
        signAndBroadcast: undefined,
    };
    delete authShell.signAndBroadcast;
    const bankShell = {
        ...bankClient,
        signAndBroadcast: undefined,
    };
    delete bankShell.signAndBroadcast;
    const baseShell = {
        ...baseClient,
        signAndBroadcast: undefined,
    };
    delete baseShell.signAndBroadcast;
    const crisisShell = {
        ...crisisClient,
        signAndBroadcast: undefined,
    };
    delete crisisShell.signAndBroadcast;
    const distributionShell = {
        ...distributionClient,
        signAndBroadcast: undefined,
    };
    delete distributionShell.signAndBroadcast;
    const evidenceShell = {
        ...evidenceClient,
        signAndBroadcast: undefined,
    };
    delete evidenceShell.signAndBroadcast;
    const feegrantShell = {
        ...feegrantClient,
        signAndBroadcast: undefined,
    };
    delete feegrantShell.signAndBroadcast;
    const govShell = {
        ...govClient,
        signAndBroadcast: undefined,
    };
    delete govShell.signAndBroadcast;
    const mintShell = {
        ...mintClient,
        signAndBroadcast: undefined,
    };
    delete mintShell.signAndBroadcast;
    const paramsShell = {
        ...paramsClient,
        signAndBroadcast: undefined,
    };
    delete paramsShell.signAndBroadcast;
    const slashingShell = {
        ...slashingClient,
        signAndBroadcast: undefined,
    };
    delete slashingShell.signAndBroadcast;
    const stakingShell = {
        ...stakingClient,
        signAndBroadcast: undefined,
    };
    delete stakingShell.signAndBroadcast;
    const txShell = {
        ...txClient,
        signAndBroadcast: undefined,
    };
    delete txShell.signAndBroadcast;
    const upgradeShell = {
        ...upgradeClient,
        signAndBroadcast: undefined,
    };
    delete upgradeShell.signAndBroadcast;
    const vestingShell = {
        ...vestingClient,
        signAndBroadcast: undefined,
    };
    delete vestingShell.signAndBroadcast;
    const wasmShell = {
        ...wasmClient,
        signAndBroadcast: undefined,
    };
    delete wasmShell.signAndBroadcast;
    const output = client;
    output.core = coreShell;
    output.auth = authShell;
    output.bank = bankShell;
    output.base = baseShell;
    output.crisis = crisisShell;
    output.distribution = distributionShell;
    output.evidence = evidenceShell;
    output.feegrant = feegrantShell;
    output.gov = govShell;
    output.mint = mintShell;
    output.params = paramsShell;
    output.slashing = slashingShell;
    output.staking = stakingShell;
    output.tx = txShell;
    output.upgrade = upgradeShell;
    output.vesting = vestingShell;
    output.wasm = wasmShell;
    return output;
};
exports.getWormchainSigningClient = getWormchainSigningClient;
