"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getAddress = exports.getOperatorWallet = exports.getWallet = void 0;
const proto_signing_1 = require("@cosmjs/proto-signing");
const consts_1 = require("./consts");
async function getWallet(mnemonic, options) {
    console.log("wallet");
    const wallet = await proto_signing_1.DirectSecp256k1HdWallet.fromMnemonic(mnemonic, {
        prefix: consts_1.ADDRESS_PREFIX,
    });
    return wallet;
}
exports.getWallet = getWallet;
async function getOperatorWallet(mnemonic, options) {
    const wallet = await proto_signing_1.DirectSecp256k1HdWallet.fromMnemonic(mnemonic, {
        prefix: consts_1.OPERATOR_PREFIX,
    });
    return wallet;
}
exports.getOperatorWallet = getOperatorWallet;
async function getAddress(wallet) {
    //There are actually up to 5 accounts in a cosmos wallet. I believe this returns the first wallet.
    const [{ address }] = await wallet.getAccounts();
    return address;
}
exports.getAddress = getAddress;
