"use strict";
//@ts-nocheck
// THIS FILE IS GENERATED AUTOMATICALLY. DO NOT MODIFY.
Object.defineProperty(exports, "__esModule", { value: true });
exports.queryClient = exports.txClient = exports.registry = exports.MissingWalletError = void 0;
const stargate_1 = require("@cosmjs/stargate");
const proto_signing_1 = require("@cosmjs/proto-signing");
const rest_1 = require("./rest");
const tx_1 = require("./types/cosmwasm/wasm/v1/tx");
const tx_2 = require("./types/cosmwasm/wasm/v1/tx");
const tx_3 = require("./types/cosmwasm/wasm/v1/tx");
const ibc_1 = require("./types/cosmwasm/wasm/v1/ibc");
const tx_4 = require("./types/cosmwasm/wasm/v1/tx");
const tx_5 = require("./types/cosmwasm/wasm/v1/tx");
const tx_6 = require("./types/cosmwasm/wasm/v1/tx");
const tx_7 = require("./types/cosmwasm/wasm/v1/tx");
const ibc_2 = require("./types/cosmwasm/wasm/v1/ibc");
const types = [
    ["/cosmwasm.wasm.v1.MsgInstantiateContract", tx_1.MsgInstantiateContract],
    ["/cosmwasm.wasm.v1.MsgUpdateAdmin", tx_2.MsgUpdateAdmin],
    ["/cosmwasm.wasm.v1.MsgInstantiateContract2", tx_3.MsgInstantiateContract2],
    ["/cosmwasm.wasm.v1.MsgIBCCloseChannel", ibc_1.MsgIBCCloseChannel],
    ["/cosmwasm.wasm.v1.MsgMigrateContract", tx_4.MsgMigrateContract],
    ["/cosmwasm.wasm.v1.MsgStoreCode", tx_5.MsgStoreCode],
    ["/cosmwasm.wasm.v1.MsgExecuteContract", tx_6.MsgExecuteContract],
    ["/cosmwasm.wasm.v1.MsgClearAdmin", tx_7.MsgClearAdmin],
    ["/cosmwasm.wasm.v1.MsgIBCSend", ibc_2.MsgIBCSend],
];
exports.MissingWalletError = new Error("wallet is required");
exports.registry = new proto_signing_1.Registry(types);
const defaultFee = {
    amount: [],
    gas: "200000",
};
const txClient = async (wallet, { addr: addr } = { addr: "http://localhost:26657" }) => {
    if (!wallet)
        throw exports.MissingWalletError;
    let client;
    if (addr) {
        client = await stargate_1.SigningStargateClient.connectWithSigner(addr, wallet, { registry: exports.registry });
    }
    else {
        client = await stargate_1.SigningStargateClient.offline(wallet, { registry: exports.registry });
    }
    const { address } = (await wallet.getAccounts())[0];
    return {
        signAndBroadcast: (msgs, { fee, memo } = { fee: defaultFee, memo: "" }) => client.signAndBroadcast(address, msgs, fee, memo),
        msgInstantiateContract: (data) => ({ typeUrl: "/cosmwasm.wasm.v1.MsgInstantiateContract", value: tx_1.MsgInstantiateContract.fromPartial(data) }),
        msgUpdateAdmin: (data) => ({ typeUrl: "/cosmwasm.wasm.v1.MsgUpdateAdmin", value: tx_2.MsgUpdateAdmin.fromPartial(data) }),
        msgInstantiateContract2: (data) => ({ typeUrl: "/cosmwasm.wasm.v1.MsgInstantiateContract2", value: tx_3.MsgInstantiateContract2.fromPartial(data) }),
        msgIBCCloseChannel: (data) => ({ typeUrl: "/cosmwasm.wasm.v1.MsgIBCCloseChannel", value: ibc_1.MsgIBCCloseChannel.fromPartial(data) }),
        msgMigrateContract: (data) => ({ typeUrl: "/cosmwasm.wasm.v1.MsgMigrateContract", value: tx_4.MsgMigrateContract.fromPartial(data) }),
        msgStoreCode: (data) => ({ typeUrl: "/cosmwasm.wasm.v1.MsgStoreCode", value: tx_5.MsgStoreCode.fromPartial(data) }),
        msgExecuteContract: (data) => ({ typeUrl: "/cosmwasm.wasm.v1.MsgExecuteContract", value: tx_6.MsgExecuteContract.fromPartial(data) }),
        msgClearAdmin: (data) => ({ typeUrl: "/cosmwasm.wasm.v1.MsgClearAdmin", value: tx_7.MsgClearAdmin.fromPartial(data) }),
        msgIBCSend: (data) => ({ typeUrl: "/cosmwasm.wasm.v1.MsgIBCSend", value: ibc_2.MsgIBCSend.fromPartial(data) }),
    };
};
exports.txClient = txClient;
const queryClient = async ({ addr: addr } = { addr: "http://localhost:1317" }) => {
    return new rest_1.Api({ baseUrl: addr });
};
exports.queryClient = queryClient;
