import { StdFee } from "@cosmjs/launchpad";
import { Registry, OfflineSigner, EncodeObject } from "@cosmjs/proto-signing";
import { Api } from "./rest";
import { MsgCreateDenom } from "./types/osmosis/tokenfactory/v1beta1/tx";
import { MsgMint } from "./types/osmosis/tokenfactory/v1beta1/tx";
import { MsgForceTransfer } from "./types/osmosis/tokenfactory/v1beta1/tx";
import { MsgSetDenomMetadata } from "./types/osmosis/tokenfactory/v1beta1/tx";
import { MsgBurn } from "./types/osmosis/tokenfactory/v1beta1/tx";
import { MsgChangeAdmin } from "./types/osmosis/tokenfactory/v1beta1/tx";
export declare const MissingWalletError: Error;
export declare const registry: Registry;
interface TxClientOptions {
    addr: string;
}
interface SignAndBroadcastOptions {
    fee: StdFee;
    memo?: string;
}
declare const txClient: (wallet: OfflineSigner, { addr: addr }?: TxClientOptions) => Promise<{
    signAndBroadcast: (msgs: EncodeObject[], { fee, memo }?: SignAndBroadcastOptions) => any;
    msgCreateDenom: (data: MsgCreateDenom) => EncodeObject;
    msgMint: (data: MsgMint) => EncodeObject;
    msgForceTransfer: (data: MsgForceTransfer) => EncodeObject;
    msgSetDenomMetadata: (data: MsgSetDenomMetadata) => EncodeObject;
    msgBurn: (data: MsgBurn) => EncodeObject;
    msgChangeAdmin: (data: MsgChangeAdmin) => EncodeObject;
}>;
interface QueryClientOptions {
    addr: string;
}
declare const queryClient: ({ addr: addr }?: QueryClientOptions) => Promise<Api<unknown>>;
export { txClient, queryClient, };
