"use strict";
//@ts-nocheck
// THIS FILE IS GENERATED AUTOMATICALLY. DO NOT MODIFY.
Object.defineProperty(exports, "__esModule", { value: true });
exports.queryClient = exports.txClient = exports.registry = exports.MissingWalletError = void 0;
const stargate_1 = require("@cosmjs/stargate");
const proto_signing_1 = require("@cosmjs/proto-signing");
const rest_1 = require("./rest");
const tx_1 = require("./types/osmosis/tokenfactory/v1beta1/tx");
const tx_2 = require("./types/osmosis/tokenfactory/v1beta1/tx");
const tx_3 = require("./types/osmosis/tokenfactory/v1beta1/tx");
const tx_4 = require("./types/osmosis/tokenfactory/v1beta1/tx");
const tx_5 = require("./types/osmosis/tokenfactory/v1beta1/tx");
const tx_6 = require("./types/osmosis/tokenfactory/v1beta1/tx");
const types = [
    ["/osmosis.tokenfactory.v1beta1.MsgCreateDenom", tx_1.MsgCreateDenom],
    ["/osmosis.tokenfactory.v1beta1.MsgMint", tx_2.MsgMint],
    ["/osmosis.tokenfactory.v1beta1.MsgForceTransfer", tx_3.MsgForceTransfer],
    ["/osmosis.tokenfactory.v1beta1.MsgSetDenomMetadata", tx_4.MsgSetDenomMetadata],
    ["/osmosis.tokenfactory.v1beta1.MsgBurn", tx_5.MsgBurn],
    ["/osmosis.tokenfactory.v1beta1.MsgChangeAdmin", tx_6.MsgChangeAdmin],
];
exports.MissingWalletError = new Error("wallet is required");
exports.registry = new proto_signing_1.Registry(types);
const defaultFee = {
    amount: [],
    gas: "200000",
};
const txClient = async (wallet, { addr: addr } = { addr: "http://localhost:26657" }) => {
    if (!wallet)
        throw exports.MissingWalletError;
    let client;
    if (addr) {
        client = await stargate_1.SigningStargateClient.connectWithSigner(addr, wallet, { registry: exports.registry });
    }
    else {
        client = await stargate_1.SigningStargateClient.offline(wallet, { registry: exports.registry });
    }
    const { address } = (await wallet.getAccounts())[0];
    return {
        signAndBroadcast: (msgs, { fee, memo } = { fee: defaultFee, memo: "" }) => client.signAndBroadcast(address, msgs, fee, memo),
        msgCreateDenom: (data) => ({ typeUrl: "/osmosis.tokenfactory.v1beta1.MsgCreateDenom", value: tx_1.MsgCreateDenom.fromPartial(data) }),
        msgMint: (data) => ({ typeUrl: "/osmosis.tokenfactory.v1beta1.MsgMint", value: tx_2.MsgMint.fromPartial(data) }),
        msgForceTransfer: (data) => ({ typeUrl: "/osmosis.tokenfactory.v1beta1.MsgForceTransfer", value: tx_3.MsgForceTransfer.fromPartial(data) }),
        msgSetDenomMetadata: (data) => ({ typeUrl: "/osmosis.tokenfactory.v1beta1.MsgSetDenomMetadata", value: tx_4.MsgSetDenomMetadata.fromPartial(data) }),
        msgBurn: (data) => ({ typeUrl: "/osmosis.tokenfactory.v1beta1.MsgBurn", value: tx_5.MsgBurn.fromPartial(data) }),
        msgChangeAdmin: (data) => ({ typeUrl: "/osmosis.tokenfactory.v1beta1.MsgChangeAdmin", value: tx_6.MsgChangeAdmin.fromPartial(data) }),
    };
};
exports.txClient = txClient;
const queryClient = async ({ addr: addr } = { addr: "http://localhost:1317" }) => {
    return new rest_1.Api({ baseUrl: addr });
};
exports.queryClient = queryClient;
