import { StdFee } from "@cosmjs/launchpad";
import { Registry, OfflineSigner, EncodeObject } from "@cosmjs/proto-signing";
import { Api } from "./rest";
import { MsgExecuteGatewayGovernanceVaa } from "./types/wormhole/tx";
import { MsgRegisterAccountAsGuardian } from "./types/wormhole/tx";
import { MsgInstantiateContract } from "./types/wormhole/tx";
import { MsgExecuteGovernanceVAA } from "./types/wormhole/tx";
import { MsgStoreCode } from "./types/wormhole/tx";
import { MsgAddWasmInstantiateAllowlist } from "./types/wormhole/tx";
import { MsgDeleteWasmInstantiateAllowlist } from "./types/wormhole/tx";
import { MsgMigrateContract } from "./types/wormhole/tx";
import { MsgDeleteAllowlistEntryRequest } from "./types/wormhole/tx";
import { MsgCreateAllowlistEntryRequest } from "./types/wormhole/tx";
export declare const MissingWalletError: Error;
export declare const registry: Registry;
interface TxClientOptions {
    addr: string;
}
interface SignAndBroadcastOptions {
    fee: StdFee;
    memo?: string;
}
declare const txClient: (wallet: OfflineSigner, { addr: addr }?: TxClientOptions) => Promise<{
    signAndBroadcast: (msgs: EncodeObject[], { fee, memo }?: SignAndBroadcastOptions) => any;
    msgExecuteGatewayGovernanceVaa: (data: MsgExecuteGatewayGovernanceVaa) => EncodeObject;
    msgRegisterAccountAsGuardian: (data: MsgRegisterAccountAsGuardian) => EncodeObject;
    msgInstantiateContract: (data: MsgInstantiateContract) => EncodeObject;
    msgExecuteGovernanceVAA: (data: MsgExecuteGovernanceVAA) => EncodeObject;
    msgStoreCode: (data: MsgStoreCode) => EncodeObject;
    msgAddWasmInstantiateAllowlist: (data: MsgAddWasmInstantiateAllowlist) => EncodeObject;
    msgDeleteWasmInstantiateAllowlist: (data: MsgDeleteWasmInstantiateAllowlist) => EncodeObject;
    msgMigrateContract: (data: MsgMigrateContract) => EncodeObject;
    msgDeleteAllowlistEntryRequest: (data: MsgDeleteAllowlistEntryRequest) => EncodeObject;
    msgCreateAllowlistEntryRequest: (data: MsgCreateAllowlistEntryRequest) => EncodeObject;
}>;
interface QueryClientOptions {
    addr: string;
}
declare const queryClient: ({ addr: addr }?: QueryClientOptions) => Promise<Api<unknown>>;
export { txClient, queryClient, };
