"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Config = exports.protobufPackage = void 0;
//@ts-nocheck
/* eslint-disable */
const Long = __importStar(require("long"));
const minimal_1 = require("protobufjs/minimal");
exports.protobufPackage = "wormhole_foundation.wormchain.wormhole";
const baseConfig = {
    guardian_set_expiration: 0,
    governance_chain: 0,
    chain_id: 0,
};
exports.Config = {
    encode(message, writer = minimal_1.Writer.create()) {
        if (message.guardian_set_expiration !== 0) {
            writer.uint32(8).uint64(message.guardian_set_expiration);
        }
        if (message.governance_emitter.length !== 0) {
            writer.uint32(18).bytes(message.governance_emitter);
        }
        if (message.governance_chain !== 0) {
            writer.uint32(24).uint32(message.governance_chain);
        }
        if (message.chain_id !== 0) {
            writer.uint32(32).uint32(message.chain_id);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof Uint8Array ? new minimal_1.Reader(input) : input;
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = { ...baseConfig };
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.guardian_set_expiration = longToNumber(reader.uint64());
                    break;
                case 2:
                    message.governance_emitter = reader.bytes();
                    break;
                case 3:
                    message.governance_chain = reader.uint32();
                    break;
                case 4:
                    message.chain_id = reader.uint32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const message = { ...baseConfig };
        if (object.guardian_set_expiration !== undefined &&
            object.guardian_set_expiration !== null) {
            message.guardian_set_expiration = Number(object.guardian_set_expiration);
        }
        else {
            message.guardian_set_expiration = 0;
        }
        if (object.governance_emitter !== undefined &&
            object.governance_emitter !== null) {
            message.governance_emitter = bytesFromBase64(object.governance_emitter);
        }
        if (object.governance_chain !== undefined &&
            object.governance_chain !== null) {
            message.governance_chain = Number(object.governance_chain);
        }
        else {
            message.governance_chain = 0;
        }
        if (object.chain_id !== undefined && object.chain_id !== null) {
            message.chain_id = Number(object.chain_id);
        }
        else {
            message.chain_id = 0;
        }
        return message;
    },
    toJSON(message) {
        const obj = {};
        message.guardian_set_expiration !== undefined &&
            (obj.guardian_set_expiration = message.guardian_set_expiration);
        message.governance_emitter !== undefined &&
            (obj.governance_emitter = base64FromBytes(message.governance_emitter !== undefined
                ? message.governance_emitter
                : new Uint8Array()));
        message.governance_chain !== undefined &&
            (obj.governance_chain = message.governance_chain);
        message.chain_id !== undefined && (obj.chain_id = message.chain_id);
        return obj;
    },
    fromPartial(object) {
        const message = { ...baseConfig };
        if (object.guardian_set_expiration !== undefined &&
            object.guardian_set_expiration !== null) {
            message.guardian_set_expiration = object.guardian_set_expiration;
        }
        else {
            message.guardian_set_expiration = 0;
        }
        if (object.governance_emitter !== undefined &&
            object.governance_emitter !== null) {
            message.governance_emitter = object.governance_emitter;
        }
        else {
            message.governance_emitter = new Uint8Array();
        }
        if (object.governance_chain !== undefined &&
            object.governance_chain !== null) {
            message.governance_chain = object.governance_chain;
        }
        else {
            message.governance_chain = 0;
        }
        if (object.chain_id !== undefined && object.chain_id !== null) {
            message.chain_id = object.chain_id;
        }
        else {
            message.chain_id = 0;
        }
        return message;
    },
};
var globalThis = (() => {
    if (typeof globalThis !== "undefined")
        return globalThis;
    if (typeof self !== "undefined")
        return self;
    if (typeof window !== "undefined")
        return window;
    if (typeof global !== "undefined")
        return global;
    throw "Unable to locate global object";
})();
const atob = globalThis.atob ||
    ((b64) => globalThis.Buffer.from(b64, "base64").toString("binary"));
function bytesFromBase64(b64) {
    const bin = atob(b64);
    const arr = new Uint8Array(bin.length);
    for (let i = 0; i < bin.length; ++i) {
        arr[i] = bin.charCodeAt(i);
    }
    return arr;
}
const btoa = globalThis.btoa ||
    ((bin) => globalThis.Buffer.from(bin, "binary").toString("base64"));
function base64FromBytes(arr) {
    const bin = [];
    for (let i = 0; i < arr.byteLength; ++i) {
        bin.push(String.fromCharCode(arr[i]));
    }
    return btoa(bin.join(""));
}
function longToNumber(long) {
    if (long.gt(Number.MAX_SAFE_INTEGER)) {
        throw new globalThis.Error("Value is larger than Number.MAX_SAFE_INTEGER");
    }
    return long.toNumber();
}
if (minimal_1.util.Long !== Long) {
    minimal_1.util.Long = Long;
    (0, minimal_1.configure)();
}
