"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.GenesisState = exports.protobufPackage = void 0;
//@ts-nocheck
/* eslint-disable */
const guardian_1 = require("../wormhole/guardian");
const config_1 = require("../wormhole/config");
const replay_protection_1 = require("../wormhole/replay_protection");
const sequence_counter_1 = require("../wormhole/sequence_counter");
const consensus_guardian_set_index_1 = require("../wormhole/consensus_guardian_set_index");
const minimal_1 = require("protobufjs/minimal");
exports.protobufPackage = "wormhole_foundation.wormchain.wormhole";
const baseGenesisState = {};
exports.GenesisState = {
    encode(message, writer = minimal_1.Writer.create()) {
        for (const v of message.guardianSetList) {
            guardian_1.GuardianSet.encode(v, writer.uint32(10).fork()).ldelim();
        }
        if (message.config !== undefined) {
            config_1.Config.encode(message.config, writer.uint32(18).fork()).ldelim();
        }
        for (const v of message.replayProtectionList) {
            replay_protection_1.ReplayProtection.encode(v, writer.uint32(26).fork()).ldelim();
        }
        for (const v of message.sequenceCounterList) {
            sequence_counter_1.SequenceCounter.encode(v, writer.uint32(34).fork()).ldelim();
        }
        if (message.consensusGuardianSetIndex !== undefined) {
            consensus_guardian_set_index_1.ConsensusGuardianSetIndex.encode(message.consensusGuardianSetIndex, writer.uint32(42).fork()).ldelim();
        }
        for (const v of message.guardianValidatorList) {
            guardian_1.GuardianValidator.encode(v, writer.uint32(50).fork()).ldelim();
        }
        for (const v of message.allowedAddresses) {
            guardian_1.ValidatorAllowedAddress.encode(v, writer.uint32(58).fork()).ldelim();
        }
        for (const v of message.wasmInstantiateAllowlist) {
            guardian_1.WasmInstantiateAllowedContractCodeId.encode(v, writer.uint32(66).fork()).ldelim();
        }
        if (message.ibcComposabilityMwContract !== undefined) {
            guardian_1.IbcComposabilityMwContract.encode(message.ibcComposabilityMwContract, writer.uint32(74).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof Uint8Array ? new minimal_1.Reader(input) : input;
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = { ...baseGenesisState };
        message.guardianSetList = [];
        message.replayProtectionList = [];
        message.sequenceCounterList = [];
        message.guardianValidatorList = [];
        message.allowedAddresses = [];
        message.wasmInstantiateAllowlist = [];
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.guardianSetList.push(guardian_1.GuardianSet.decode(reader, reader.uint32()));
                    break;
                case 2:
                    message.config = config_1.Config.decode(reader, reader.uint32());
                    break;
                case 3:
                    message.replayProtectionList.push(replay_protection_1.ReplayProtection.decode(reader, reader.uint32()));
                    break;
                case 4:
                    message.sequenceCounterList.push(sequence_counter_1.SequenceCounter.decode(reader, reader.uint32()));
                    break;
                case 5:
                    message.consensusGuardianSetIndex = consensus_guardian_set_index_1.ConsensusGuardianSetIndex.decode(reader, reader.uint32());
                    break;
                case 6:
                    message.guardianValidatorList.push(guardian_1.GuardianValidator.decode(reader, reader.uint32()));
                    break;
                case 7:
                    message.allowedAddresses.push(guardian_1.ValidatorAllowedAddress.decode(reader, reader.uint32()));
                    break;
                case 8:
                    message.wasmInstantiateAllowlist.push(guardian_1.WasmInstantiateAllowedContractCodeId.decode(reader, reader.uint32()));
                    break;
                case 9:
                    message.ibcComposabilityMwContract = guardian_1.IbcComposabilityMwContract.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const message = { ...baseGenesisState };
        message.guardianSetList = [];
        message.replayProtectionList = [];
        message.sequenceCounterList = [];
        message.guardianValidatorList = [];
        message.allowedAddresses = [];
        message.wasmInstantiateAllowlist = [];
        if (object.guardianSetList !== undefined &&
            object.guardianSetList !== null) {
            for (const e of object.guardianSetList) {
                message.guardianSetList.push(guardian_1.GuardianSet.fromJSON(e));
            }
        }
        if (object.config !== undefined && object.config !== null) {
            message.config = config_1.Config.fromJSON(object.config);
        }
        else {
            message.config = undefined;
        }
        if (object.replayProtectionList !== undefined &&
            object.replayProtectionList !== null) {
            for (const e of object.replayProtectionList) {
                message.replayProtectionList.push(replay_protection_1.ReplayProtection.fromJSON(e));
            }
        }
        if (object.sequenceCounterList !== undefined &&
            object.sequenceCounterList !== null) {
            for (const e of object.sequenceCounterList) {
                message.sequenceCounterList.push(sequence_counter_1.SequenceCounter.fromJSON(e));
            }
        }
        if (object.consensusGuardianSetIndex !== undefined &&
            object.consensusGuardianSetIndex !== null) {
            message.consensusGuardianSetIndex = consensus_guardian_set_index_1.ConsensusGuardianSetIndex.fromJSON(object.consensusGuardianSetIndex);
        }
        else {
            message.consensusGuardianSetIndex = undefined;
        }
        if (object.guardianValidatorList !== undefined &&
            object.guardianValidatorList !== null) {
            for (const e of object.guardianValidatorList) {
                message.guardianValidatorList.push(guardian_1.GuardianValidator.fromJSON(e));
            }
        }
        if (object.allowedAddresses !== undefined &&
            object.allowedAddresses !== null) {
            for (const e of object.allowedAddresses) {
                message.allowedAddresses.push(guardian_1.ValidatorAllowedAddress.fromJSON(e));
            }
        }
        if (object.wasmInstantiateAllowlist !== undefined &&
            object.wasmInstantiateAllowlist !== null) {
            for (const e of object.wasmInstantiateAllowlist) {
                message.wasmInstantiateAllowlist.push(guardian_1.WasmInstantiateAllowedContractCodeId.fromJSON(e));
            }
        }
        if (object.ibcComposabilityMwContract !== undefined &&
            object.ibcComposabilityMwContract !== null) {
            message.ibcComposabilityMwContract = guardian_1.IbcComposabilityMwContract.fromJSON(object.ibcComposabilityMwContract);
        }
        else {
            message.ibcComposabilityMwContract = undefined;
        }
        return message;
    },
    toJSON(message) {
        const obj = {};
        if (message.guardianSetList) {
            obj.guardianSetList = message.guardianSetList.map((e) => e ? guardian_1.GuardianSet.toJSON(e) : undefined);
        }
        else {
            obj.guardianSetList = [];
        }
        message.config !== undefined &&
            (obj.config = message.config ? config_1.Config.toJSON(message.config) : undefined);
        if (message.replayProtectionList) {
            obj.replayProtectionList = message.replayProtectionList.map((e) => e ? replay_protection_1.ReplayProtection.toJSON(e) : undefined);
        }
        else {
            obj.replayProtectionList = [];
        }
        if (message.sequenceCounterList) {
            obj.sequenceCounterList = message.sequenceCounterList.map((e) => e ? sequence_counter_1.SequenceCounter.toJSON(e) : undefined);
        }
        else {
            obj.sequenceCounterList = [];
        }
        message.consensusGuardianSetIndex !== undefined &&
            (obj.consensusGuardianSetIndex = message.consensusGuardianSetIndex
                ? consensus_guardian_set_index_1.ConsensusGuardianSetIndex.toJSON(message.consensusGuardianSetIndex)
                : undefined);
        if (message.guardianValidatorList) {
            obj.guardianValidatorList = message.guardianValidatorList.map((e) => e ? guardian_1.GuardianValidator.toJSON(e) : undefined);
        }
        else {
            obj.guardianValidatorList = [];
        }
        if (message.allowedAddresses) {
            obj.allowedAddresses = message.allowedAddresses.map((e) => e ? guardian_1.ValidatorAllowedAddress.toJSON(e) : undefined);
        }
        else {
            obj.allowedAddresses = [];
        }
        if (message.wasmInstantiateAllowlist) {
            obj.wasmInstantiateAllowlist = message.wasmInstantiateAllowlist.map((e) => e ? guardian_1.WasmInstantiateAllowedContractCodeId.toJSON(e) : undefined);
        }
        else {
            obj.wasmInstantiateAllowlist = [];
        }
        message.ibcComposabilityMwContract !== undefined &&
            (obj.ibcComposabilityMwContract = message.ibcComposabilityMwContract
                ? guardian_1.IbcComposabilityMwContract.toJSON(message.ibcComposabilityMwContract)
                : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = { ...baseGenesisState };
        message.guardianSetList = [];
        message.replayProtectionList = [];
        message.sequenceCounterList = [];
        message.guardianValidatorList = [];
        message.allowedAddresses = [];
        message.wasmInstantiateAllowlist = [];
        if (object.guardianSetList !== undefined &&
            object.guardianSetList !== null) {
            for (const e of object.guardianSetList) {
                message.guardianSetList.push(guardian_1.GuardianSet.fromPartial(e));
            }
        }
        if (object.config !== undefined && object.config !== null) {
            message.config = config_1.Config.fromPartial(object.config);
        }
        else {
            message.config = undefined;
        }
        if (object.replayProtectionList !== undefined &&
            object.replayProtectionList !== null) {
            for (const e of object.replayProtectionList) {
                message.replayProtectionList.push(replay_protection_1.ReplayProtection.fromPartial(e));
            }
        }
        if (object.sequenceCounterList !== undefined &&
            object.sequenceCounterList !== null) {
            for (const e of object.sequenceCounterList) {
                message.sequenceCounterList.push(sequence_counter_1.SequenceCounter.fromPartial(e));
            }
        }
        if (object.consensusGuardianSetIndex !== undefined &&
            object.consensusGuardianSetIndex !== null) {
            message.consensusGuardianSetIndex = consensus_guardian_set_index_1.ConsensusGuardianSetIndex.fromPartial(object.consensusGuardianSetIndex);
        }
        else {
            message.consensusGuardianSetIndex = undefined;
        }
        if (object.guardianValidatorList !== undefined &&
            object.guardianValidatorList !== null) {
            for (const e of object.guardianValidatorList) {
                message.guardianValidatorList.push(guardian_1.GuardianValidator.fromPartial(e));
            }
        }
        if (object.allowedAddresses !== undefined &&
            object.allowedAddresses !== null) {
            for (const e of object.allowedAddresses) {
                message.allowedAddresses.push(guardian_1.ValidatorAllowedAddress.fromPartial(e));
            }
        }
        if (object.wasmInstantiateAllowlist !== undefined &&
            object.wasmInstantiateAllowlist !== null) {
            for (const e of object.wasmInstantiateAllowlist) {
                message.wasmInstantiateAllowlist.push(guardian_1.WasmInstantiateAllowedContractCodeId.fromPartial(e));
            }
        }
        if (object.ibcComposabilityMwContract !== undefined &&
            object.ibcComposabilityMwContract !== null) {
            message.ibcComposabilityMwContract = guardian_1.IbcComposabilityMwContract.fromPartial(object.ibcComposabilityMwContract);
        }
        else {
            message.ibcComposabilityMwContract = undefined;
        }
        return message;
    },
};
