import { Writer, Reader } from "protobufjs/minimal";
export declare const protobufPackage = "wormhole_foundation.wormchain.wormhole";
export interface GuardianKey {
    key: Uint8Array;
}
export interface GuardianValidator {
    guardianKey: Uint8Array;
    validatorAddr: Uint8Array;
}
export interface GuardianSet {
    index: number;
    keys: Uint8Array[];
    expirationTime: number;
}
export interface ValidatorAllowedAddress {
    /** the validator/guardian that controls this entry */
    validator_address: string;
    /** the allowlisted account */
    allowed_address: string;
    /** human readable name */
    name: string;
}
export interface WasmInstantiateAllowedContractCodeId {
    /** bech32 address of the contract that can call wasm instantiate without a VAA */
    contract_address: string;
    /** reference to the stored WASM code that can be instantiated */
    code_id: number;
}
export interface IbcComposabilityMwContract {
    /** bech32 address of the contract that is used by the ibc composability middleware */
    contract_address: string;
}
export declare const GuardianKey: {
    encode(message: GuardianKey, writer?: Writer): Writer;
    decode(input: Reader | Uint8Array, length?: number | undefined): GuardianKey;
    fromJSON(object: any): GuardianKey;
    toJSON(message: GuardianKey): unknown;
    fromPartial(object: DeepPartial<GuardianKey>): GuardianKey;
};
export declare const GuardianValidator: {
    encode(message: GuardianValidator, writer?: Writer): Writer;
    decode(input: Reader | Uint8Array, length?: number | undefined): GuardianValidator;
    fromJSON(object: any): GuardianValidator;
    toJSON(message: GuardianValidator): unknown;
    fromPartial(object: DeepPartial<GuardianValidator>): GuardianValidator;
};
export declare const GuardianSet: {
    encode(message: GuardianSet, writer?: Writer): Writer;
    decode(input: Reader | Uint8Array, length?: number | undefined): GuardianSet;
    fromJSON(object: any): GuardianSet;
    toJSON(message: GuardianSet): unknown;
    fromPartial(object: DeepPartial<GuardianSet>): GuardianSet;
};
export declare const ValidatorAllowedAddress: {
    encode(message: ValidatorAllowedAddress, writer?: Writer): Writer;
    decode(input: Reader | Uint8Array, length?: number | undefined): ValidatorAllowedAddress;
    fromJSON(object: any): ValidatorAllowedAddress;
    toJSON(message: ValidatorAllowedAddress): unknown;
    fromPartial(object: DeepPartial<ValidatorAllowedAddress>): ValidatorAllowedAddress;
};
export declare const WasmInstantiateAllowedContractCodeId: {
    encode(message: WasmInstantiateAllowedContractCodeId, writer?: Writer): Writer;
    decode(input: Reader | Uint8Array, length?: number | undefined): WasmInstantiateAllowedContractCodeId;
    fromJSON(object: any): WasmInstantiateAllowedContractCodeId;
    toJSON(message: WasmInstantiateAllowedContractCodeId): unknown;
    fromPartial(object: DeepPartial<WasmInstantiateAllowedContractCodeId>): WasmInstantiateAllowedContractCodeId;
};
export declare const IbcComposabilityMwContract: {
    encode(message: IbcComposabilityMwContract, writer?: Writer): Writer;
    decode(input: Reader | Uint8Array, length?: number | undefined): IbcComposabilityMwContract;
    fromJSON(object: any): IbcComposabilityMwContract;
    toJSON(message: IbcComposabilityMwContract): unknown;
    fromPartial(object: DeepPartial<IbcComposabilityMwContract>): IbcComposabilityMwContract;
};
declare type Builtin = Date | Function | Uint8Array | string | number | undefined;
export declare type DeepPartial<T> = T extends Builtin ? T : T extends Array<infer U> ? Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
export {};
